/*
Interactions

`Interactions are managed by our flow designer in UI, what you can control via api is how you start and run interaction flow for contact sending events.  Interaction can start in a multiple ways:  - EntryPont - when contact scans QR code ar opens entry point link  - event as trigger - this way you can start flow for single contact  ## Events Events are a data structure related to some contact action. You can use them whenever you want to start active interaction for contact but also inside interaction flow you can define points wher system should wait for custom event sent from your side.   Depending on your use case our predefined interactions might have defined events and instruction what events should be sent.  Events can be sent directly using our REST Api or triggered automatically by our integration modules.  ## Adding attributes to events Adding attributest to event can personalize communication, select branch flow based on attribute value or use them as perameters in other interaction flow actions. Use `body` property in event structure to add key-value attributes. 

API version: 1.0
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package interactions

import (
	"encoding/json"
)

// checks if the CxTemplateInstallationMutableData type satisfies the MappedNullable interface at compile time
var _ MappedNullable = &CxTemplateInstallationMutableData{}

// CxTemplateInstallationMutableData struct for CxTemplateInstallationMutableData
type CxTemplateInstallationMutableData struct {
	PrepareData *CxTemplateInstallationMutableDataPrepareData `json:"prepare_data,omitempty"`
	CustomizationsData []CxTemplateInstallationMutableDataCustomizationsDataInner `json:"customizations_data,omitempty"`
	WizardData map[string]interface{} `json:"wizard_data,omitempty"`
	ChannelId *string `json:"channel_id,omitempty"`
	InteractionsCustomData []CxTemplateInstallationMutableDataInteractionsCustomDataInner `json:"interactions_custom_data,omitempty"`
	TriggersCustomData []CxTemplateInstallationMutableDataTriggersCustomDataInner `json:"triggers_custom_data,omitempty"`
}

// NewCxTemplateInstallationMutableData instantiates a new CxTemplateInstallationMutableData object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewCxTemplateInstallationMutableData() *CxTemplateInstallationMutableData {
	this := CxTemplateInstallationMutableData{}
	return &this
}

// NewCxTemplateInstallationMutableDataWithDefaults instantiates a new CxTemplateInstallationMutableData object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewCxTemplateInstallationMutableDataWithDefaults() *CxTemplateInstallationMutableData {
	this := CxTemplateInstallationMutableData{}
	return &this
}

// GetPrepareData returns the PrepareData field value if set, zero value otherwise.
func (o *CxTemplateInstallationMutableData) GetPrepareData() CxTemplateInstallationMutableDataPrepareData {
	if o == nil || IsNil(o.PrepareData) {
		var ret CxTemplateInstallationMutableDataPrepareData
		return ret
	}
	return *o.PrepareData
}

// GetPrepareDataOk returns a tuple with the PrepareData field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *CxTemplateInstallationMutableData) GetPrepareDataOk() (*CxTemplateInstallationMutableDataPrepareData, bool) {
	if o == nil || IsNil(o.PrepareData) {
		return nil, false
	}
	return o.PrepareData, true
}

// HasPrepareData returns a boolean if a field has been set.
func (o *CxTemplateInstallationMutableData) HasPrepareData() bool {
	if o != nil && !IsNil(o.PrepareData) {
		return true
	}

	return false
}

// SetPrepareData gets a reference to the given CxTemplateInstallationMutableDataPrepareData and assigns it to the PrepareData field.
func (o *CxTemplateInstallationMutableData) SetPrepareData(v CxTemplateInstallationMutableDataPrepareData) {
	o.PrepareData = &v
}

// GetCustomizationsData returns the CustomizationsData field value if set, zero value otherwise.
func (o *CxTemplateInstallationMutableData) GetCustomizationsData() []CxTemplateInstallationMutableDataCustomizationsDataInner {
	if o == nil || IsNil(o.CustomizationsData) {
		var ret []CxTemplateInstallationMutableDataCustomizationsDataInner
		return ret
	}
	return o.CustomizationsData
}

// GetCustomizationsDataOk returns a tuple with the CustomizationsData field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *CxTemplateInstallationMutableData) GetCustomizationsDataOk() ([]CxTemplateInstallationMutableDataCustomizationsDataInner, bool) {
	if o == nil || IsNil(o.CustomizationsData) {
		return nil, false
	}
	return o.CustomizationsData, true
}

// HasCustomizationsData returns a boolean if a field has been set.
func (o *CxTemplateInstallationMutableData) HasCustomizationsData() bool {
	if o != nil && !IsNil(o.CustomizationsData) {
		return true
	}

	return false
}

// SetCustomizationsData gets a reference to the given []CxTemplateInstallationMutableDataCustomizationsDataInner and assigns it to the CustomizationsData field.
func (o *CxTemplateInstallationMutableData) SetCustomizationsData(v []CxTemplateInstallationMutableDataCustomizationsDataInner) {
	o.CustomizationsData = v
}

// GetWizardData returns the WizardData field value if set, zero value otherwise.
func (o *CxTemplateInstallationMutableData) GetWizardData() map[string]interface{} {
	if o == nil || IsNil(o.WizardData) {
		var ret map[string]interface{}
		return ret
	}
	return o.WizardData
}

// GetWizardDataOk returns a tuple with the WizardData field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *CxTemplateInstallationMutableData) GetWizardDataOk() (map[string]interface{}, bool) {
	if o == nil || IsNil(o.WizardData) {
		return map[string]interface{}{}, false
	}
	return o.WizardData, true
}

// HasWizardData returns a boolean if a field has been set.
func (o *CxTemplateInstallationMutableData) HasWizardData() bool {
	if o != nil && !IsNil(o.WizardData) {
		return true
	}

	return false
}

// SetWizardData gets a reference to the given map[string]interface{} and assigns it to the WizardData field.
func (o *CxTemplateInstallationMutableData) SetWizardData(v map[string]interface{}) {
	o.WizardData = v
}

// GetChannelId returns the ChannelId field value if set, zero value otherwise.
func (o *CxTemplateInstallationMutableData) GetChannelId() string {
	if o == nil || IsNil(o.ChannelId) {
		var ret string
		return ret
	}
	return *o.ChannelId
}

// GetChannelIdOk returns a tuple with the ChannelId field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *CxTemplateInstallationMutableData) GetChannelIdOk() (*string, bool) {
	if o == nil || IsNil(o.ChannelId) {
		return nil, false
	}
	return o.ChannelId, true
}

// HasChannelId returns a boolean if a field has been set.
func (o *CxTemplateInstallationMutableData) HasChannelId() bool {
	if o != nil && !IsNil(o.ChannelId) {
		return true
	}

	return false
}

// SetChannelId gets a reference to the given string and assigns it to the ChannelId field.
func (o *CxTemplateInstallationMutableData) SetChannelId(v string) {
	o.ChannelId = &v
}

// GetInteractionsCustomData returns the InteractionsCustomData field value if set, zero value otherwise.
func (o *CxTemplateInstallationMutableData) GetInteractionsCustomData() []CxTemplateInstallationMutableDataInteractionsCustomDataInner {
	if o == nil || IsNil(o.InteractionsCustomData) {
		var ret []CxTemplateInstallationMutableDataInteractionsCustomDataInner
		return ret
	}
	return o.InteractionsCustomData
}

// GetInteractionsCustomDataOk returns a tuple with the InteractionsCustomData field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *CxTemplateInstallationMutableData) GetInteractionsCustomDataOk() ([]CxTemplateInstallationMutableDataInteractionsCustomDataInner, bool) {
	if o == nil || IsNil(o.InteractionsCustomData) {
		return nil, false
	}
	return o.InteractionsCustomData, true
}

// HasInteractionsCustomData returns a boolean if a field has been set.
func (o *CxTemplateInstallationMutableData) HasInteractionsCustomData() bool {
	if o != nil && !IsNil(o.InteractionsCustomData) {
		return true
	}

	return false
}

// SetInteractionsCustomData gets a reference to the given []CxTemplateInstallationMutableDataInteractionsCustomDataInner and assigns it to the InteractionsCustomData field.
func (o *CxTemplateInstallationMutableData) SetInteractionsCustomData(v []CxTemplateInstallationMutableDataInteractionsCustomDataInner) {
	o.InteractionsCustomData = v
}

// GetTriggersCustomData returns the TriggersCustomData field value if set, zero value otherwise.
func (o *CxTemplateInstallationMutableData) GetTriggersCustomData() []CxTemplateInstallationMutableDataTriggersCustomDataInner {
	if o == nil || IsNil(o.TriggersCustomData) {
		var ret []CxTemplateInstallationMutableDataTriggersCustomDataInner
		return ret
	}
	return o.TriggersCustomData
}

// GetTriggersCustomDataOk returns a tuple with the TriggersCustomData field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *CxTemplateInstallationMutableData) GetTriggersCustomDataOk() ([]CxTemplateInstallationMutableDataTriggersCustomDataInner, bool) {
	if o == nil || IsNil(o.TriggersCustomData) {
		return nil, false
	}
	return o.TriggersCustomData, true
}

// HasTriggersCustomData returns a boolean if a field has been set.
func (o *CxTemplateInstallationMutableData) HasTriggersCustomData() bool {
	if o != nil && !IsNil(o.TriggersCustomData) {
		return true
	}

	return false
}

// SetTriggersCustomData gets a reference to the given []CxTemplateInstallationMutableDataTriggersCustomDataInner and assigns it to the TriggersCustomData field.
func (o *CxTemplateInstallationMutableData) SetTriggersCustomData(v []CxTemplateInstallationMutableDataTriggersCustomDataInner) {
	o.TriggersCustomData = v
}

func (o CxTemplateInstallationMutableData) MarshalJSON() ([]byte, error) {
	toSerialize,err := o.ToMap()
	if err != nil {
		return []byte{}, err
	}
	return json.Marshal(toSerialize)
}

func (o CxTemplateInstallationMutableData) ToMap() (map[string]interface{}, error) {
	toSerialize := map[string]interface{}{}
	if !IsNil(o.PrepareData) {
		toSerialize["prepare_data"] = o.PrepareData
	}
	if !IsNil(o.CustomizationsData) {
		toSerialize["customizations_data"] = o.CustomizationsData
	}
	if !IsNil(o.WizardData) {
		toSerialize["wizard_data"] = o.WizardData
	}
	if !IsNil(o.ChannelId) {
		toSerialize["channel_id"] = o.ChannelId
	}
	if !IsNil(o.InteractionsCustomData) {
		toSerialize["interactions_custom_data"] = o.InteractionsCustomData
	}
	if !IsNil(o.TriggersCustomData) {
		toSerialize["triggers_custom_data"] = o.TriggersCustomData
	}
	return toSerialize, nil
}

type NullableCxTemplateInstallationMutableData struct {
	value *CxTemplateInstallationMutableData
	isSet bool
}

func (v NullableCxTemplateInstallationMutableData) Get() *CxTemplateInstallationMutableData {
	return v.value
}

func (v *NullableCxTemplateInstallationMutableData) Set(val *CxTemplateInstallationMutableData) {
	v.value = val
	v.isSet = true
}

func (v NullableCxTemplateInstallationMutableData) IsSet() bool {
	return v.isSet
}

func (v *NullableCxTemplateInstallationMutableData) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableCxTemplateInstallationMutableData(val *CxTemplateInstallationMutableData) *NullableCxTemplateInstallationMutableData {
	return &NullableCxTemplateInstallationMutableData{value: val, isSet: true}
}

func (v NullableCxTemplateInstallationMutableData) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableCxTemplateInstallationMutableData) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}


